//xsetaseta@gmail.com
//11/05/2017

#include <SoftwareSerial.h>

// #define _DEBUG

#define MAXENTRADA 50
#define BUSY 2

char buffer[MAXENTRADA]="";
int contador=0;
char stringComplete = false; 

struct FDPCOMAND { unsigned int ncmd; char nombre[10];};
struct FDPCOMAND comandos[20]= { 0,"__",1,"NEXT",2,"PREV",3,"PLAYN",4,"VOL+",5,"VOL-",6,"VOLUMEN",7,"EQA",8,"MODE",9,"SOURCE",                                
10,"STANDBY",11,"NORMAL",12,"RESET",13,"PLAY",14,"PAUSE",15,"FOLDER",16,"VOLUMEN",17,"REPEAT",18,"HELP"};

int comando2,comando3,valorComando2,valorComando3,nucomandos;
unsigned char DATASEND[10]=   {0x7E, 0xFF, 0x06, 0 ,0, 0, 0, 0, 0, 0xEF};

int runFuniones(void);
void SendData(unsigned char comando,int dato1);
int trazar(void);
void MinToMay(char string[]);


SoftwareSerial mySerial(10, 11); // RX, TX

void setup()
{
  mySerial.begin(9600);
  Serial.begin(9600);
  pinMode(BUSY, INPUT);
  pinMode(13, OUTPUT);
  Serial.println("SETA DFPLayer");
  play("volumen 20");
  
 }


void loop()
{
 
  playw("folder 1,1");
  playw("folder 1,2");
  playw("folder 1,3");
  playw("playn 13");

}

//_____________________________________________

void playw(char *bufferS)
{
  int i=0;
      for (i=0;i<MAXENTRADA;++i)  buffer[i]=bufferS[i];
      MinToMay();
      Serial.println(buffer);     
      trazar();
      runFuniones();
      delay(300);
      while(digitalRead(BUSY)!=HIGH){}
}

void play(char *bufferS)
{
  int i=0;
      for (i=0;i<MAXENTRADA;++i)  buffer[i]=bufferS[i];
      MinToMay();
      Serial.println(buffer);     
      trazar();
      runFuniones();
}

void MinToMay(void)
{
  int i=0;
  int desp='a'-'A';

  for (i=0;buffer[i]!='\0';++i)
  {
    if(buffer[i]>='a'&&buffer[i]<='z') buffer[i]=buffer[i]-desp;
  }
}


int runFuniones(void)
{
  int z;
  for (z=0;z<20;z++)
  {
   if(!strcmp(buffer,comandos[z].nombre))
    { 
      Serial.print("OK Comando-orden>"); Serial.println(comandos[z].ncmd);
      goto salto1;
    }   
  }
  Serial.println("ERROR comando->");
  return(-1);
salto1:;

  switch(comandos[z].ncmd)
  {
    
  case 3:   
      SendData(comandos[z].ncmd,valorComando2); //Specify tracking(NUM)
    break;
  case 6:   
      SendData(comandos[z].ncmd,valorComando2); //Specify volume
    break;
  case 7:   
      SendData(comandos[z].ncmd,valorComando2); //Specify EQ(0/1/2/3/4/5)
    break;
  case 8:   
      SendData(comandos[z].ncmd,valorComando2); //Specify playback mode (0/1/2/3)
    break;
  case 9:   
       //source
    break;
  case 15:   
      SendData(comandos[z].ncmd,valorComando2*256+valorComando3); //Specify folder to playback
    break;
  case 16:   
      SendData(comandos[z].ncmd,valorComando2); //Volume adjust set
    break;
  case 17:   
      SendData(comandos[z].ncmd,valorComando2); //Repeat play
    break;
  case 18:   
       //help
       Serial.print("__Ordenes__");
       for (z=0;z<20;z++)   Serial.println(comandos[z].nombre);
    break;
 
  default:
      SendData(comandos[z].ncmd,0); //next
  break;
    
  } 
  return(0);
}


void SendData(unsigned char comando,int dato1)
{
 int z;
 unsigned int suma;

  DATASEND[3]=comando;
  DATASEND[5]=dato1>>8;
  DATASEND[6]=dato1 & 0xFF;
  suma=DATASEND[1]+DATASEND[2]+DATASEND[3]+DATASEND[4]+DATASEND[5]+DATASEND[6];
  suma=0-suma;
  DATASEND[7]=suma>>8;
  DATASEND[8]=suma & 0x00FF;
 
  for(z=0;z<10;z++)
    {
       mySerial.write(DATASEND[z]);
#ifdef _DEBUG       
     Serial.print(DATASEND[z],HEX ); Serial.print(" "); 
#endif       
    }   
}

int trazar(void)
{
  int z;


  comando2=0;      
  comando3=0;
  nucomandos=0;
      for(z=0;z<MAXENTRADA;z++)
        {
          if(buffer[z]=='\n' || buffer[z]==0) { break;}
          if(buffer[z]==32 || buffer[z]==',' ) 
            {
               if(comando2==0)
                {buffer[z]=0; comando2=z+1;nucomandos++;}
                else
                {buffer[z]=0; comando3=z+1;nucomandos++;}
            }
         
        }
  valorComando2=atoi(buffer+comando2);
    valorComando3=atoi(buffer+comando3);
#ifdef _DEBUG   
  Serial.print("Numerocomandos>");Serial.println(nucomandos);
  Serial.print("comando1>");Serial.println(buffer);
  Serial.print("comando2>");Serial.println(buffer+comando2);
  Serial.print("comando3>");Serial.println(buffer+comando3);
  Serial.print("Valorcomando2>");Serial.println(valorComando2);
  Serial.print("Valorcomando3>");Serial.println(valorComando3);
#endif  
  return(nucomandos);
}
